<?php

if (!defined('IN_SITE'))
{
	die();
}

################################################################################
#	unidb class
################################################################################

class unidb
{
	var $querynum = 0;
	var $conn = '';
	var $dbtype = 'mysql'; # default value of db type, other aviables variants: postgres, odbc, oracle, mssql

	///////////////////////
	// select database type
	///////////////////////

	function set_db_type($type="mysql")
	{
		$this->dbtype = $type;
	}

	////////////////
	// connect to db
	////////////////

	function connect($dbhost="localhost", $dbuser, $dbpw, $dbname, $port="", $pconnect=0)
	{
	        if($pconnect)
	                 {
	                         switch($this->dbtype)
	                         {
	                                 case 'postgres':
	                                         $port = ($port!="") ? "port=".$port : $port;
	                                         $this->conn = pg_pconnect("host={$dbhost} $port dbname={$dbname} user={$dbuser} password={$dbpw}");
	                                         break;
	                                 case 'oracle':
	                                         $this->conn = (function_exists('oci_pconnect')) ? oci_pconnect($dbuser, $dbpw, $dbname) : ociplogon($dbuser, $dbpw, $dbname);
	                                         break;
	                                 case 'mssql':
	                                         $this->conn = mssql_pconnect($dbhost, $dbuser, $dbpw);
	                                         break;
	                                 case 'odbc':
	                                         $this->conn = odbc_pconnect($dbhost, $dbuser, $dbpw);
	                                         break;
	                                 default:
	                                         $port = ($port!="") ? ":".$port : $port;
	                                         $this->conn = mysql_pconnect($dbhost.$port, $dbuser, $dbpw);
	                         }
	        } else
	                 {
	                         switch($this->dbtype)
	                         {
	                                 case 'postgres':
	                                         $port = ($port!="") ? "port=".$port : $port;
	                                         $this->conn = pg_connect("host={$dbhost} $port dbname={$dbname} user={$dbuser} password={$dbpw}");
	                                         break;
	                                 case 'oracle':
	                                         $this->conn = (function_exists('oci_connect')) ? oci_connect($dbuser, $dbpw, $dbname) : ocilogon($dbuser, $dbpw, $dbname);
	                                         break;
	                                 case 'mssql':
	                                         $this->conn = mssql_connect($dbhost, $dbuser, $dbpw);
	                                         break;
	                                 case 'odbc':
	                                         $this->conn = odbc_connect($dbhost, $dbuser, $dbpw);
	                                         break;
	                                 default:
	                                         $port = ($port!="") ? ":".$port : $port;
	                                         $this->conn = mysql_connect($dbhost.$port, $dbuser, $dbpw);
	                         }
	        }
	                 switch($this->dbtype)
	                 {
	                         case 'postgres':
	                                 break;
	                         case 'oracle':
	                                 break;
	                         case 'mssql':
	                                 mssql_select_db($dbname, $this->conn);
	                                 break;
	                         case 'odbc':
	                                 break;
	                         default:
	                                 mysql_select_db($dbname, $this->conn);
	                 }
	}

	///////////////////
	// close connection
	///////////////////

	function close()
	{
		if ($this->conn!="")
		{
			switch($this->dbtype)
			{
				case 'postgres':
					pg_close($this->conn);
					break;
				case 'oracle':
					if (function_exists('oci_close')) oci_close($this->conn); else ociclose($this->conn);
					break;
				case 'mssql':
					mssql_close($this->conn);
					break;
				case 'odbc':
					odbc_close($this->conn);
					break;
				default:
					mysql_close($this->conn);
			}
		}
	}

	//////////////////////////
	// fetch array from result
	//////////////////////////

    	function fetch_array($query, $res_type = "") {
		switch($this->dbtype)
		{
			case 'postgres':
				$query = pq_fetch_array($query);
				break;
			case 'oracle':
				$res_type = ($res_type=="") ? OCI_BOTH : $res_type;
				$query = oci_fetch_array($query, $res_type);
				break;
			case 'mssql':
				$res_type = ($res_type=="") ? MSSQL_BOTH : $res_type;
				$query = mssql_fetch_array($query, $res_type);
				break;
			case 'odbc':
				$query = odbc_fetch_array($query);
				break;
			default:
				$res_type = ($res_type=="") ? MYSQL_BOTH : $res_type;
				$query = mysql_fetch_array($query, $res_type);
		}
        		return $query;
	}

	//////////////
	// exec query
	//////////////

	function query($sql)
	{
		switch($this->dbtype)
		{
			case 'postgres':
				$query = pg_query($this->conn, $sql);
				break;
			case 'oracle':
				if (function_exists('oci_execute'))
				{
					$query = oci_parse($this->conn, $sql);
					oci_execute($query);
				}
				else
				{
					$query = ociparse($this->conn, $sql);
					ociexecute($query);
				}
				break;
			case 'mssql':
				$query = mssql_query($sql, $this->conn);
				break;
			case 'odbc':
				$query = odbc_exec($this->conn, $sql);
				break;
			default:
				$query = mysql_query($sql, $this->conn);
		}
		$this->querynum++;
		return $query;
	}

	//////////////////////////////////////
	// return predefined row from resource
	//////////////////////////////////////

	function result($query, $row)
	{
		switch($this->dbtype)
		{
			case 'postgres':
				$query = pg_fetch_result($query, $row);
				break;
			case 'oracle':
				$query = FALSE;
				break;
			case 'mssql':
				$query = mssql_result($query, $row);
				break;
			case 'odbc':
				$query = FALSE;
				break;
			default:
				$query = mysql_result($query, $row);
		}
		return $query;
	}

	//////////////////////////////////
	// return num rows of the resource
	//////////////////////////////////

    	function num_rows($query)
	{

		switch($this->dbtype)
		{
			case 'postgres':
				$query = pg_num_rows($query);
				break;
			case 'oracle':
				$query = (function_exists('oci_num_rows')) ? oci_num_rows($query) : ocirowcount($query);
				break;
			case 'mssql':
				$query = mssql_num_rows($query);
				break;
			case 'odbc':
				$query = odbc_num_rows($query);
				break;
			default:
				$query = mysql_num_rows($query);
		}
        		return $query;
	}

	////////////////////////
	// return last insert id
	////////////////////////

    	function get_last_insert_id()
	{
		switch($this->dbtype)
		{
			case 'postgres':
				$query = pg_num_rows($query);
				break;
			case 'oracle':
				$query = (function_exists('oci_num_rows')) ? oci_num_rows($query) : ocirowcount($query);
				break;
			case 'mssql':
				$query = mssql_num_rows($query);
				break;
			case 'odbc':
				$query = odbc_num_rows($query);
				break;
			default:
				$id = mysql_insert_id();
		}
        		return $id;
	}

	////////////////////////////////
	// fetch current row of resource
	////////////////////////////////

	function fetch_row($query)
	{
		switch($this->dbtype)
		{
			case 'postgres':
				$query = pg_fetch_row($query);
				break;
			case 'oracle':
				$query = oci_fetch_row($query);
				break;
			case 'mssql':
				$query = mssql_fetch_row($query);
				break;
			case 'odbc':
				$query = odbc_fetch_row($query);
				break;
			default:
		        $query = mysql_fetch_row($query);
		}
        		return $query;
	}

	///////////////////////////////////////////////////////
	// fetch predefined field of the first row of the query
	///////////////////////////////////////////////////////

	function fetch_field($sql, $field)
	{
		switch($this->dbtype)
		{
			case 'postgres':
				$query = pg_query($this->conn, $sql);
				$this->querynum++;
				$query = pg_fetch_row($query);
				$query = $query[$field];
				break;
			case 'oracle':
				if (function_exists('oci_execute'))
				{
					$query = oci_parse($this->conn, $sql);
					oci_execute($query);
				}
				else
				{
					$query = ociparse($this->conn, $sql);
					ociexecute($query);
				}
				$this->querynum++;
				$query = oci_fetch_row($query);
				$query = $query[$field];
				break;
			case 'mssql':
				$query = mssql_query($sql, $this->conn);
				$this->querynum++;
				$query = mssql_fetch_row($query);
				$query = $query[$field];
				break;
			case 'odbc':
				$query = odbc_exec($this->conn, $sql);
				$this->querynum++;
				$query = odbc_fetch_row($query);
				$query = $query[$field];
				break;
			default:
				$query = mysql_query($sql, $this->conn);
				$this->querynum++;
				$query = mysql_fetch_row($query);
				$query = $query[$field];
		}
        		return $query;
	}
}


?>