<?php

if (!defined('IN_SITE'))
{
	die();
}

function generate_start_date($type)
{
	$possible_types = array('hour', 'day', 'week', 'month');
	$default_value = date("d.m.Y H:i:s", mktime() - 24 * 3600);
	if (!in_array($type, $possible_types) )
	{
		# return day ago value
		return $default_value;
	}
	else
	{
		# generating date
		$current = getdate();
		switch ($type)
		{
			case 'hour':
				$ut = mktime($current['hours'], 0, 0);
			break;
			case 'day':
				$ut = mktime(0, 0, 0);
			break;
			case 'week':
				$tt = getdate(time() - ($current['wday']-1) * 24 * 3600);
				$ut = mktime(0, 0, 0, $tt['mon'], $tt['mday']);
			break;
			case 'month':
				$ut = mktime(0, 0, 0, $current['mon'], 1);
			break;
		}
		return date("d.m.Y H:i:s", $ut);
	}
}

function getmicrotime()
{
	list($usec, $sec) = explode(" ",microtime());
	return ((float)$usec + (float)$sec);
}

function array_add_prefix_to_keys($arr, $prefix)
{
	$out = array();
	foreach($arr as $k=>$v) $out[$prefix.$k] = $v;
	return $out;
}

function generate_not_src_ip_condition($cond)
{
	$out = "";
	if (trim($cond) != "")
	{
		$out = "AND (INET_NTOA(src) NOT LIKE '%" . $cond . "%')";
	} 
	return $out;
}

function get_accounts_list(&$db, $for_select_tag = false)
{
	$acc_list = ($for_select_tag) ? "" : array();
											   // WHERE oid IN (SELECT DISTINCT(unit_oid) FROM monitor) 
	$r = $db->query("SELECT oid, name FROM oids ORDER BY name ASC");
	while($row = $db->fetch_array($r))
	{
		if ($for_select_tag)		
		{
			$acc_list .= "<option value=\"$row[oid]\">$row[name]</option>";	
		}
		else
			$acc_list[] = $row;
	}
	return $acc_list;
}

function my_strtotime($s)
{
	$s = trim($s);
	$a = explode(' ', $s);
	$b = explode('.', $a[0]);
	$c = explode(':', $a[1]);
	if (count($c)<3) $c[2] = '00';
	return mktime($c[0], $c[1], $c[2], $b[1], $b[0], $b[2]);
}

function js_goto_url($url)
{
	echo "<script language=\"JavaScript1.2\">document.location.href = '$url'; </script>";
}

function check_quot_amp($s)
{
	$s = str_replace('&', '&#38;', $s);
	$s = str_replace('"', '&#34;', $s);
	return $s;
}

function get_table_on_pages(&$db, $sql, $var_name, $pp, $apx_to_url, $next_char = "&raquo;", $prev_char = "&laquo;")
{
	$rx = $db->query($sql);
	$rows_count = $db->num_rows($rx);
	$pp = ($pp < 1) ? $rows_count : $pp;
	$page_count = (int) ($rows_count / $pp);
	if ($page_count < ($rows_count / $pp))  $page_count++;
	$tmp = "";
	if (isset($_GET[$var_name]) and $_GET[$var_name] != "")
		$current_page = (((int)$_GET[$var_name])>$page_count) ? $page_count : (int) $_GET[$var_name];
	else
		$current_page = 1;
	settype($current_page, "integer");
	if ($current_page == 0) $current_page = 1;

	if ($current_page>1)
	{
		$prev = $current_page - 1;
		$tmp .= "<a href=\"?{$apx_to_url}{$var_name}={$prev}\">$prev_char</a>&nbsp;";
	}

	$d1_start = ($current_page>5) ? 4 : 0;
	$d1_end =  ($current_page>5) ? $current_page-2 : 0;
	$d1_end =  ($d1_end>($page_count-3)) ? $page_count-3 : $d1_end;
	$d2_start = ($current_page<($page_count-4)) ? $current_page + 2 : 0;
	$d2_start = (($d2_start<=3) and $d2_start!=0) ? 4 : $d2_start;
	$d2_end = ($current_page<($page_count-4)) ? $page_count - 3 : 0;
	$is_d1 = false;
	$is_d2 = false;

	for($i=1; $i<=$page_count; $i++)
	{
		if ($page_count > 1)
		{

			if ($i!=$current_page) 
			{
				if ((($i<$d1_start)  or ($i>$d1_end)) and (($i<$d2_start) or ($i>$d2_end)))
				{
					$tmp .= "&nbsp;<a href=\"?{$apx_to_url}{$var_name}={$i}\">$i</a>&nbsp;"; 
				}
				if ((($i>=$d1_start)  and ($i<=$d1_end)) and !$is_d1)
				{
					$tmp .= "&nbsp;...&nbsp;";
					$is_d1 = true;
				}
				if ((($i>=$d2_start)  and ($i<=$d2_end)) and !$is_d2)
				{
					$tmp .= "&nbsp;...&nbsp;";
					$is_d2 = true;
				}
			}
			else $tmp .= " $i ";
		}
	}
	if ($current_page < $page_count)
	{
			$next = $current_page + 1;
			$tmp .= "&nbsp;<a href=\"?{$apx_to_url}{$var_name}={$next}\">{$next_char}</a>";
	}

	# output

	$first_rec = ($current_page - 1) * $pp;
	$pos = 0;
	$counter = 0;
	
	$out["table"] = array();

	while(($row = $db->fetch_array($rx, MYSQL_ASSOC))  && $counter<$pp)
	{
		if ($pos>=($first_rec-1))
		{
			$out["table"][] = $row;
			$counter++;
		}
		$pos++;
	}

	$out["selected_rows_count"] = count($out["table"]);
	$out["rows_count"] = $rows_count;
	$out["per_page"] = $pp;
	$out["var_name"] = $var_name;
	$out["current_page"] = $current_page;
	$out["nav_code"] = ($tmp!='') ? ' ' . $tmp : '';

	return $out;
}

function addslashes_for_array(&$arr) 
{
	foreach($arr as $k=>$v) 
	{
    if (is_array($v)) 
		{
			addslashes_for_array($v);
			$arr[$k] = $v;
		}
		else 
		{
			$arr[$k] = addslashes($v);
		}
	}
}

function fix_magic_quotes_gpc() 
{
	if (!get_magic_quotes_gpc()) 
	{
		addslashes_for_array($_POST);
	   	addslashes_for_array($_GET);
   		addslashes_for_array($_COOKIE);
	}
}

function my_iconv($from, $to, $s)
{
	$output = $s;
	if (function_exists('iconv'))
	{
		$output = iconv($from, $to, $s);
	}
	return $output;
}

?>