<?php

if (!defined('IN_SITE'))
{
	die();
}

$port_desc = array
(
	113  =>array('auth','identification protocol'),
	179  =>array('bgp','border gateway protocol'),
	68   =>array('bootpc','bootstrap protocol client'),
	67   =>array('bootps','bootstrap protocol server'),
	19   =>array('chargen',''),
	514  =>array('cmd',''),
	531  =>array('conference',''),
	530  =>array('courier',''),
	13   =>array('daytime',''),
	9    =>array('discard',''),
	53   =>array('domain',''),
	666  =>array('doom','doom id software'),
	7    =>array('echo',''),
	520  =>array('efs','extended file name server'),
	135  =>array('epmap','dce endpoint resolution'),
	512  =>array('exec','remote process execution'),
	79   =>array('finger',''),
	21   =>array('ftp',''),
	20   =>array('ftp-data',''),
	70   =>array('gopher',''),
	101  =>array('hostname','nic host name server'),
	80   =>array('http','world wide web'),
	443  =>array('https',''),
	143  =>array('imap','internet message access protocol'),
	1524 =>array('ingreslock',''),
	213  =>array('ipx','ipx over ip'),
	194  =>array('irc','internet relay chat protocol'),
	500  =>array('isakmp','internet key exchange'),
	102  =>array('iso-tsap','iso-tsap class 0'),
	88   =>array('kerberos','kerberos'),
	749  =>array('kerberos-adm','kerberos administration'),
	750  =>array('kerberos-iv','kerberos version iv'),
	543  =>array('klogin','kerberos login'),
	2053 =>array('knetd','kerberos de-multiplexor'),
	464  =>array('kpasswd','kerberos (v5)'),
	1109 =>array('kpop','kerberos pop'),
	544  =>array('kshell','kerberos remote shell'),
	1701 =>array('l2tp','layer two tunneling protocol'),
	389  =>array('ldap','lightweight directory access protocol'),
	636  =>array('ldaps','ldap over tls/ssl'),
	513  =>array('login','remote login'),
	9535 =>array('man','remote man server'),
	445  =>array('microsoft-ds',''),
	561  =>array('monitor',''),
	1433 =>array('ms-sql-s','microsoft-sql-server'),
	1434 =>array('ms-sql-m','microsoft-sql-monitor'),
	42   =>array('nameserver','host name server'),
	138  =>array('netbios-dgm','netbios datagram service'),
	137  =>array('netbios-ns','netbios name service'),
	139  =>array('netbios-ssn','netbios session service'),
	532  =>array('netnews',''),
	533  =>array('netwall','for emergency broadcasts'),
	550  =>array('new-rwho',''),
	2049 =>array('nfsd','nfs server'),
	43   =>array('nicname','domain name server'),
	119  =>array('nntp','network news transfer protocol'),
	518  =>array('ntalk',''),
	123  =>array('ntp','network time protocol'),
	158  =>array('pcmail-srv','pcmail server'),
	1167 =>array('phone','conference calling'),
	109  =>array('pop2','post office protocol - version 2'),
	110  =>array('pop3','post office protocol - version 3'),
	1723 =>array('pptp','point-to-point tunnelling protocol'),
	170  =>array('print-srv','network postscript'),
	515  =>array('printer',''),
	17   =>array('qotd',''),
	1813 =>array('radacct','radius accounting protocol'),
	1812 =>array('radius','radius authentication protocol'),
	556  =>array('remotefs','rfs_server'),
	39   =>array('rlp','resource location protocol'),
	560  =>array('rmonitor','rmonitord'),
	107  =>array('rtelnet','remote telnet service'),
	25   =>array('smtp',''),
	161  =>array('snmp','snmp'),
	162  =>array('snmptrap','snmp trap'),
	11   =>array('systat',''),
	111  =>array('sunrpc','sun remote procedure call'),
	517  =>array('talk',''),
	23   =>array('telnet',''),
	526  =>array('tempo',''),
	69   =>array('tftp','trivial file transfer'),
	37   =>array('time',''),
	525  =>array('timed',''),
	540  =>array('uucp',''),
	117  =>array('uucp-path',''),
	1512 =>array('wins','microsoft windows internet name service')
);

$proto_desc = array
(
	8=>array('egp', 'exterior gateway protocol'),
	3=>array('ggp', 'gateway-gateway protocol'),
	20=>array('hmp', 'host monitoring protocol'),
	0=>array('ip', 'internet protocol'),
	1=>array('icmp', 'internet control message protocol'),
	12=>array('pup', 'parc universal packet protocol'),
	27=>array('rdp', 'reliable datagram protocol'),
	66=>array('rvd', 'MIT remote virtual disk'),
	6=>array('tcp', 'transmission control protocol'),
	17=>array('udp', 'user datagram protocol'),
	22=>array('xns-idp', 'xerox ns idp')
);

ksort($port_desc, SORT_NUMERIC);

function get_proto_desc($n)
{
	global $proto_desc;
	if (!isset($proto_desc[$n])) $s = array($n, "unknow protocol"); else $s = $proto_desc[$n];
	return $s;
}
	
function get_port_desc($n)
{
	global $port_desc;
	if (!isset($port_desc[$n])) $s = array($n, "unknow port"); else $s = $port_desc[$n];
	return $s;
}

function get_dns_cache($cache_file)
{
	$dns_c = array();
	clearstatcache();
	if (file_exists($cache_file))
	{
		$a = @file($cache_file);
	foreach($a as $v)
	{
		$b = explode('=', trim($v, " \n\r"));
		$dns_c[$b[0]] = $b[1];
	}
	}
	return $dns_c;
}

function gethostbyaddr_ex($ip, &$dns_cache)
{
	if (!isset($dns_cache[$ip]))
	{
		$host = gethostbyaddr($ip);
		if (trim($ip) != "" and trim($host) !="" ) $dns_cache[$ip] = $host;
	}
	else $host = $dns_cache[$ip];
	if (trim($host)=='') $host = $ip;
	return $host;
}

function set_dns_cache($cache_file, $dns_cache)
{
	$dns_c = array();
	array_unique($dns_cache);
	foreach($dns_cache as $k=>$v) if (trim($k)!="" and trim($v)!="") $dns_c[] = $k . "=" . $v;
	if (!$handle = fopen($cache_file, 'w')) exit;
	if (fwrite($handle, implode("\r\n", $dns_c)) === FALSE) exit;
	fclose($handle);
	@chmod($cache_file, 0666);
}

function get_protocol_list()
{
	global $proto_desc, $_LANG;

	$pd = $proto_desc;

	$lst = '<option value="">' . $_LANG['ANY'] . '</option>';
	foreach($pd as $id=>$data)
	{
			$name = $data[0];
			$hint = (trim($data[1])!='') ? ' (' . $data[1] . ')' : '';
			$lst .= "<option value=\"$id\">{$name}{$hint}</option>";	
	}
	return $lst;	
}

function get_port_list()
{
	global $port_desc, $_LANG;

	$pd = $port_desc;

	$lst = '<option value="">' . $_LANG['ANY'] . '</option>';
	foreach($pd as $id=>$data)
	{
			$name = $data[0];
			$hint = (trim($data[1])!='') ? ' (' . $data[1] . ')' : '';
			$lst .= "<option value=\"$id\">{$id} : {$name}{$hint}</option>";	
	}
	return $lst;	
}

?>