<?php

if (!defined('IN_SITE'))
{
	die();
}

function get_templates_data_by_path($path)
{
	$ti = array();
	if ($handle = opendir($path)) 
	{
		while (false !== ($file = readdir($handle))) 
		{
			if ($file != "." && $file != "..") 
			{
				clearstatcache();
				$cfg_fn = $path . "/" . $file . "/index.cfg";
				$path_to_cfg = $path . "/" . $file . "/";
				if (@is_dir($path_to_cfg) && file_exists($cfg_fn))
				{
					$tmp_arr = file($cfg_fn);
					if (count($tmp_arr)>0)
					{
						foreach($tmp_arr as $k=>$v)
						{
							$tmp_arr_2 = explode("\t", trim($v));
							if (count($tmp_arr_2)>=2) $tmp_arr_3[trim(trim(strtolower($tmp_arr_2[0])), ":")] = trim($tmp_arr_2[1]);
						}
						if (isset($tmp_arr_3))
						{
							$tmp_arr_3['tpl_dir'] = $file;
							$ti[] = $tmp_arr_3;
							unset($tmp_arr_3);
						}
					}
				}
			}
		}
		closedir($handle);
	}
	return $ti;
}

class template 
{
	var $template = array();
	var $files = array();
	var $root = "";
	var $optimize = true;
	var $compiled_code = array();
	var $uncompiled_code = array();

	function set_optimize($value)
	{
		$this->optimize = $value;
	}	

	function clear_data() {
		$this->compiled_code = array();
		$this->uncompiled_code = array();
		$this->template = array();
	}

	function template($root = ".") {
		if (!is_dir($root)) {
			die('Templates directory not found');
		}
		$this->root = $root;
	}

	function set_filenames($file_array) {
		if (!is_array($file_array)) die("Function set_filenames required array as parametr");

		reset($file_array);
		while(list($handle, $file) = each($file_array)) {
			$file = $this->root . '/' . $file;
			if (!file_exists($file)) die("File ".$file." does not exist");
			$this->files[$handle] = $file;
		}
		return true;
	}

	function assign_var($varname, $varval) {
		$this->template['.'][0][$varname] = $varval;
		return true;
	}

	function assign_vars($vararray) {
		reset ($vararray);
		while (list($key, $val) = each($vararray))
			{
			$this->template['.'][0][$key] = $val;
			}
		return true;
	}

	function assign_var_from_handle($varname, $handle) {
		if(!$this->loadfile($handle)) {
			die("Template->assign_var_from_handle(): Couldn't load template file for handle $handle");
		}

		# Compile it, with the "no echo statements" option on.
		$_str = "";
		$code = $this->compile($this->uncompiled_code[$handle], true, '_str');
		eval($code);
		$this->assign_var($varname, $_str);
		return true;
	}

	function assign_block_vars($blockname, $vararray) {
		if(strstr($blockname, '.')) {
			$blocks = explode('.', $blockname);
			$blockcount = sizeof($blocks) - 1;
			$str = '$this->template';
			for ($i = 0; $i < $blockcount; $i++) {
				$str .= '[\'' . $blocks[$i] . '.\']';
				eval('$lastiteration = sizeof(' . $str . ') - 1;');
				$str .= '[' . $lastiteration . ']';
			}
			$str .= '[\'' . $blocks[$blockcount] . '.\'][] = $vararray;';
			eval($str);
		}
		else {
			$this->template[$blockname . '.'][] = $vararray;
		}
		return true;
	}

	function loadfile($handle) {
		if(isset($this->uncompiled_code[$handle]) && !empty($this->uncompiled_code[$handle])) return true;
		if(!isset($this->files[$handle])) die("template->loadfile(): No file specified for handle $handle");
		$filename = $this->files[$handle];

		$tmp = file($filename);
		foreach($tmp as $k=>$v) if ((trim($v) != "")) $x_tmp[] = trim($v);
        $tmp = $x_tmp;

		$str = implode("\r\n", $tmp);
		if(empty($str)) die("template->loadfile(): File $filename for handle $handle is empty");
		$this->uncompiled_code[$handle] = $str;
		return true;
	}

	function pparse($handle) {
		if(!$this->loadfile($handle)) die('File sets in handler is missing or empty');
		if (!isset($this->compiled_code[$handle]) || empty($this->compiled_code[$handle])) $this->compiled_code[$handle] = $this->compile($this->uncompiled_code[$handle]);
		eval($this->compiled_code[$handle]);
		return true;
	}

	function compile($code, $do_not_echo = false, $retvar = '') {
		global $CONFIG_COMPILE_HTML;
		$code = str_replace('\\', '\\\\', $code);
		$code = str_replace('\'', '\\\'', $code);

		$varrefs = array();
		preg_match_all('#\{(([a-z0-9\-_]+?\.)+?)([a-z0-9\-_]+?)\}#is', $code, $varrefs);
		$varcount = sizeof($varrefs[1]);
		for ($i = 0; $i < $varcount; $i++) {
			$namespace = $varrefs[1][$i];
			$varname = $varrefs[3][$i];
			$new = $this->generate_block_varref($namespace, $varname);

			$code = str_replace($varrefs[0][$i], $new, $code);
		}

		$code = preg_replace('#\{([a-z0-9\-_]*?)\}#is', '\' . ( ( isset($this->template[\'.\'][0][\'\1\']) ) ? $this->template[\'.\'][0][\'\1\'] : \'\' ) . \'', $code);
		$code_lines = explode("\n", $code);

		$block_nesting_level = 0;
		$block_names = array();
		$block_names[0] = ".";

		$line_count = sizeof($code_lines);
		for ($i = 0; $i < $line_count; $i++) {
			$code_lines[$i] = chop($code_lines[$i]);
			if (preg_match('#<!-- BEGIN (.*?) -->#', $code_lines[$i], $m)) {
				$n[0] = $m[0];
				$n[1] = $m[1];
				if(preg_match('#<!-- END (.*?) -->#', $code_lines[$i], $n)) {
					$block_nesting_level++;
					$block_names[$block_nesting_level] = $m[1];
					if($block_nesting_level < 2) {
						$code_lines[$i] = '$_' . $n[1] . '_count = ( isset($this->template[\'' . $n[1] . '.\']) ) ?  sizeof($this->template[\'' . $n[1] . '.\']) : 0;';
						$code_lines[$i] .= "\n" . 'for ($_' . $n[1] . '_i = 0; $_' . $n[1] . '_i < $_' . $n[1] . '_count; $_' . $n[1] . '_i++)';
						$code_lines[$i] .= "\n" . '{';
					}
					else {
						$namespace = implode('.', $block_names);
						$namespace = substr($namespace, 2);
						$varref = $this->generate_block_data_ref($namespace, false);
						$code_lines[$i] = '$_' . $n[1] . '_count = ( isset(' . $varref . ') ) ? sizeof(' . $varref . ') : 0;';
						$code_lines[$i] .= "\n" . 'for ($_' . $n[1] . '_i = 0; $_' . $n[1] . '_i < $_' . $n[1] . '_count; $_' . $n[1] . '_i++)';
						$code_lines[$i] .= "\n" . '{';
					}
					unset($block_names[$block_nesting_level]);
					$block_nesting_level--;
					$code_lines[$i] .= '} // END ' . $n[1];
					$m[0] = $n[0];
					$m[1] = $n[1];
					}
				else {
					$block_nesting_level++;
					$block_names[$block_nesting_level] = $m[1];
					if ($block_nesting_level < 2) {
						$code_lines[$i] = '$_' . $m[1] . '_count = ( isset($this->template[\'' . $m[1] . '.\']) ) ? sizeof($this->template[\'' . $m[1] . '.\']) : 0;';
						$code_lines[$i] .= "\n" . 'for ($_' . $m[1] . '_i = 0; $_' . $m[1] . '_i < $_' . $m[1] . '_count; $_' . $m[1] . '_i++)';
						$code_lines[$i] .= "\n" . '{';
					}
					else {
						$namespace = implode('.', $block_names);
						$namespace = substr($namespace, 2);
						$varref = $this->generate_block_data_ref($namespace, false);
						$code_lines[$i] = '$_' . $m[1] . '_count = ( isset(' . $varref . ') ) ? sizeof(' . $varref . ') : 0;';
						$code_lines[$i] .= "\n" . 'for ($_' . $m[1] . '_i = 0; $_' . $m[1] . '_i < $_' . $m[1] . '_count; $_' . $m[1] . '_i++)';
						$code_lines[$i] .= "\n" . '{';
					}
				}
			}
			else if (preg_match('#<!-- END (.*?) -->#', $code_lines[$i], $m)) {
				#   
				unset($block_names[$block_nesting_level]);
				$block_nesting_level--;
				$code_lines[$i] = '} // END ' . $m[1];
			}
			else {
				if (!$do_not_echo)
					{
					$code_lines[$i] = 'echo \'' . $code_lines[$i] . '\' . "\\n";';
					}
				else
					{
					$code_lines[$i] = '$' . $retvar . '.= \'' . $code_lines[$i] . '\' . "\\n";';
					}
			}
			}

		$code = implode("\n", $code_lines);
		$code = ($CONFIG_COMPILE_HTML) ? eregi_replace("\t", " ", $code) : $code;
		return $code;
	}

	function generate_block_varref($namespace, $varname) {
		$namespace = substr($namespace, 0, strlen($namespace) - 1);
		$varref = $this->generate_block_data_ref($namespace, true);
		$varref .= '[\'' . $varname . '\']';
		$varref = '\' . ( ( isset(' . $varref . ') ) ? ' . $varref . ' : \'\' ) . \'';
		return $varref;
	}

	function generate_block_data_ref($blockname, $include_last_iterator) {
		$blocks = explode(".", $blockname);
		$blockcount = sizeof($blocks) - 1;
		$varref = '$this->template';
		for ($i = 0; $i < $blockcount; $i++) {
			$varref .= '[\'' . $blocks[$i] . '.\'][$_' . $blocks[$i] . '_i]';
		}
		$varref .= '[\'' . $blocks[$blockcount] . '.\']';
		if ($include_last_iterator) {
			$varref .= '[$_' . $blocks[$blockcount] . '_i]';
		}
		return $varref;
	}
}

?>