<?php

require_once('config.inc.php');
require_once('includes/initialize.inc.php');

# get the script start time
$time1 = getmicrotime();

# set filter form handler
if (isset($_POST['action'], $_POST['accounts'], $_POST['start_time'], $_POST['end_time']) and $_POST['action']=='set_filter' and $_POST['start_time']!='' and $_POST['end_time']!='')
{
	$f = array();
	foreach($_POST['accounts'] as $v) $f['accounts'][] = $v;
	$f['start_time'] = isset($_POST['start_time']) ? $_POST['start_time'] : '';
	$f['end_time'] = isset($_POST['end_time']) ? $_POST['end_time'] : '';
	$f['group'] =  (isset($_POST['group'])) ? true : false;
	$f['resolve'] = (isset($_POST['resolve'])) ? true : false;
	$f['per_page'] = (isset($_POST['per_page']) and (((int) $_POST['per_page']) > 0) ) ? (int) $_POST['per_page'] : 25;
	$f['protocol'] =  (isset($_POST['protocol']) && $_POST['protocol']!='') ? $_POST['protocol'] : '';

	$f['source_port'] =  (isset($_POST['source_port']) && $_POST['source_port']!='') ? $_POST['source_port'] : '';
	$f['destination_port'] =  (isset($_POST['destination_port']) && $_POST['destination_port']!='') ? $_POST['destination_port'] : '';
	$_SESSION['filter'] = $f;
	js_goto_url($_CONFIG['SITE_URL']);
}

# clear filter handler
if (isset($_GET['clear']) and $_GET['clear']=='1')
{
	if (isset($_SESSION['filter'])) unset($_SESSION['filter']);
	js_goto_url($_CONFIG['SITE_URL']);
}

# if not yet set filter
if (!isset($_SESSION['filter']))
{
	# select template file
	$template->set_filenames(array("tpl" => 'index.tpl'));

	# get default datetimes
	$_USER['START_TIME'] = generate_start_date($_CONFIG['DEFAULT_START_TIME']);
	$_USER['END_TIME'] = date("d.m.Y H:i:s");
	$_USER['RESOLVE'] = ($_CONFIG['DEFAULT_RESOLVE_HOSTS']) ? 'checked="checked"' : '';
	$_USER['GROUP_DATA'] = ($_CONFIG['DEFAULT_GROUP_DATA']) ? 'checked="checked"' : '';

	# get accounts list
	$_VARS['ACCOUNTS_LIST'] = get_accounts_list($db, true);

	# get protocol list
	$_VARS['PROTOCOL_LIST'] = get_protocol_list();

	# get port's list
	$_VARS['SOURCE_PORT_LIST'] = get_port_list();
	$_VARS['DESTINATION_PORT_LIST'] = get_port_list();
}
# else if set filter then show stat
else
{
	# select template file
	$tpl_name = (isset($_GET['save'])) ? 'save.tpl' : 'results.tpl';
	$template->set_filenames(array("tpl" => $tpl_name));
	if (isset($_GET['save'])) 
	{
		$template->set_optimize(false);
	}

	# sort handler
	$scol = (isset($_GET['scol']) and ((int) $_GET['scol']>=0)) ? $_GET['scol'] : 0;
	$smod = (isset($_GET['smod']) and ($_GET['smod']=="up" or $_GET['smod']=="down")) ? $_GET['smod'] : "down";
	$sort_images = array();
	for($i=0; $i<6; $i++)
	{
		$pg = (isset($_GET['page'])) ? (int) $_GET['page'] : 1;
		$sort_images[$i] = ($scol==$i) ? (($smod=="up") ? "<img width=\"11\" height=\"9\" alt=\"\" src=\"".$_CONFIG['SITE_URL'].$_VARS['TPL_PATH']."images/sort_up.gif\" />" : "<img width=\"11\" alt=\"\" height=\"9\" src=\"".$_CONFIG['SITE_URL'].$_VARS['TPL_PATH']."images/sort_down.gif\" />") : "";
		$sort_urls[$i] = ($scol==$i) ? (($smod=="up") ? "?scol=".$i."&amp;smod=down&amp;page=".$pg : "?scol=".$i."&amp;smod=up&amp;page=".$pg) : "?scol=".$i."&amp;smod=down&amp;page=".$pg;
	}
	$sort_fields = array(0=>'time', 1=>'unit_oid', 2=>'proto', 3=>'src', 4=>'dst', 5=>'len');
	$sort_fields_2 = array(3=>'srcport', 4=>'dstport');
	$ord_apx = "ORDER BY ".$sort_fields[$scol]." ".(($smod=="down") ? "ASC" : "DESC");
	$ord_apx .= (isset($sort_fields_2[$scol])) ? ", " . $sort_fields_2[$scol] . " " . (($smod=="down") ? "ASC" : "DESC") : "";

	# time & users
	$s_time = my_strtotime($_SESSION['filter']['start_time']);
	$e_time = my_strtotime($_SESSION['filter']['end_time']);
	$acc_oid_list = implode(',', $_SESSION['filter']['accounts']);


	# protocol cond.
	$proto_cond = '';
	if ($_SESSION['filter']['protocol'] &&  $_SESSION['filter']['protocol']!='')
	{
		$proto_cond = " AND proto = '" . $_SESSION['filter']['protocol'] . "'";
	}

	# src port cond.
	$port_cond = '';
	if ($_SESSION['filter']['source_port'] &&  $_SESSION['filter']['source_port']!='')
	{
		$port_cond .= " AND srcport = '" . $_SESSION['filter']['source_port'] . "'";
	}

	# dst port cond.
	if ($_SESSION['filter']['destination_port'] &&  $_SESSION['filter']['destination_port']!='')
	{
		$port_cond .= " AND dstport = '" . $_SESSION['filter']['destination_port'] . "'";
	}

	$acc = array();
	$r = $db->query("SELECT oid, name FROM oids WHERE oid IN (" . $acc_oid_list . ") ORDER BY name ASC");

	while($row = $db->fetch_array($r)) $acc[$row['oid']] = $row['name'];
	$acc_arr = $acc;
    $acc = implode(', ', $acc);

	# generate filter description
	$_USER['FILTER_DESCRIPTION'] = $_LANG['FD_WORD_1'] . " <b>".$acc."</b> " . $_LANG['FD_WORD_2'] . " <b>" . $_SESSION['filter']['start_time'] . "</b> " . $_LANG['FD_WORD_3'] . " <b>" . $_SESSION['filter']['end_time'] . "</b>, " . ((!isset($_GET['save'])) ? $_LANG['FD_WORD_4'] . " <b>" . $_SESSION['filter']['per_page'] . "</b> " . $_LANG['FD_WORD_5'] : $_LANG['FD_WORD_13']) . ", ";
	$_USER['FILTER_DESCRIPTION'] .= $_LANG['FD_WORD_10'] . ' <b>' . (($_SESSION['filter']['protocol']!='') ? $proto_desc[$_SESSION['filter']['protocol']][0] : $_LANG['ANY']) . '</b>, ' . $_LANG['FD_WORD_11'] . ' <b>' . (($_SESSION['filter']['source_port']!='') ? $port_desc[$_SESSION['filter']['source_port']][0] : $_LANG['ANY']) . '</b>, ' . $_LANG['FD_WORD_12'] . ' <b>' . (($_SESSION['filter']['destination_port']!='') ? $port_desc[$_SESSION['filter']['destination_port']][0] : $_LANG['ANY']) . '</b>, ';
	$_USER['FILTER_DESCRIPTION'] .= ($_SESSION['filter']['resolve']) ? " <b>" . $_LANG['FD_WORD_6'] . ",</b>" : " <b>" . $_LANG['FD_WORD_7'] . "</b>,";
	$_USER['FILTER_DESCRIPTION'] .= ($_SESSION['filter']['group']) ? " <b>" . $_LANG['FD_WORD_8'] . "</b>" : " <b>" . $_LANG['FD_WORD_9'] . "</b>";
	$_USER['FILTER_DESCRIPTION'] .= ".";
	$_USER['FILTER_DESCRIPTION'] = (isset($_GET['save'])) ? wordwrap(strip_tags($_USER['FILTER_DESCRIPTION']), 80, "\r\n") : $_USER['FILTER_DESCRIPTION'];

	# generating local_ip_condition
	$not_src_ip_condition = generate_not_src_ip_condition($_CONFIG['NOT_SRC_IP_CONDITION']);


	# executing sql
	if ($_SESSION['filter']['group']) 
	{
		$table_data = get_table_on_pages($db, "SELECT time, unit_oid, proto, INET_NTOA(src) as src, srcport, INET_NTOA(dst) as dst, dstport, SUM(len) as len FROM monitor WHERE (time BETWEEN '".$s_time."' AND '".$e_time."') ".$port_cond." ".$proto_cond." AND unit_oid IN (".$acc_oid_list.") ".$not_src_ip_condition." GROUP BY unit_oid, proto, src, dst ".$ord_apx, "page", (isset($_GET['save'])) ?  -1 : $_SESSION['filter']['per_page'], "scol=".$scol."&amp;smod=".$smod."&amp;");
	}
	else
		$table_data = get_table_on_pages($db, "SELECT time, unit_oid, proto, INET_NTOA(src) as src, srcport, INET_NTOA(dst) as dst, dstport, len FROM monitor WHERE (time BETWEEN '".$s_time."' AND '".$e_time."') ".$port_cond." ".$proto_cond." AND unit_oid IN (".$acc_oid_list.") ".$not_src_ip_condition." ".$ord_apx, "page", (isset($_GET['save'])) ?  -1 : $_SESSION['filter']['per_page'], "scol=".$scol."&amp;smod=".$smod."&amp;");


	# preparing save to file href
	$_USER['SAVE_TO_FILE_HREF'] = "index.php?" . "save=1&amp;scol=".$scol."&amp;smod=".$smod;

	# summary length of trafic by filter
	$q = "SELECT SUM(len) as sm FROM monitor WHERE (time BETWEEN '".$s_time."' AND '".$e_time."') AND unit_oid IN (".$acc_oid_list.") ".$not_src_ip_condition;
	$total_sum = get_table_on_pages($db, $q, "x", -1, "");	
	$total_sum = $total_sum['table'][0]['sm'];
	$_USER['TOTAL_SUM'] = sprintf('%.2f', $total_sum / 1024);

	if ($table_data["selected_rows_count"] > 0)
	{
        $sum = 0;
		for($i=0; $i<6; $i++)
		{
			$template->assign_block_vars('header', array
			(
				'URL' => $sort_urls[$i],
				'TITLE' => $_LANG['SORT_TITLES'][$i],
				'IMG' => $sort_images[$i]
			));
		}
		if (isset($_GET['save'])) $_USER['HEADER'] = implode($_CONFIG['SAVE_STAT_FILE_DELIMITER'], $_LANG['SORT_TITLES']);

		if ($_SESSION['filter']['resolve']) $dns_cache = get_dns_cache($_CONFIG['CACHE_DIR'] . 'dns');
        for($y = 0; $y < count($table_data["table"]); $y++)
        {
			$row = $table_data["table"][$y];
            if ($_SESSION['filter']['resolve'])
            {
            	$row['src'] = '<span title="' . $row['src'] . '">' . gethostbyaddr_ex($row['src'], $dns_cache) . '</span>';
            	$row['dst'] = '<span title="' . $row['dst'] . '">' . gethostbyaddr_ex($row['dst'], $dns_cache) . '</span>';
            }

			$d = date("d.m.Y H:i:s", $row['time']);
			$acc_name = (isset($_GET['save'])) ? $acc_arr[$row['unit_oid']] : '<span title="oid: ' . $row['unit_oid'] . '">' . $acc_arr[$row['unit_oid']] . '</span>';				
            $protocol = get_proto_desc($row['proto']);
			$length = sprintf('%.2f', $row['len'] / 1024);
			$src_port_hint = get_port_desc($row['srcport']);
			$src_port_hint = $src_port_hint[0]." (".$src_port_hint[1].")";
			$src_port_hint = (trim($src_port_hint)!="()") ? $src_port_hint : "";
			$dst_port_hint = get_port_desc($row['dstport']);
			$dst_port_hint = $dst_port_hint[0]." (".$dst_port_hint[1].")";
			$dst_port_hint = (trim($dst_port_hint)!="()") ? $dst_port_hint : "";
			$sum = $sum + (int) $row['len'];

			$template->assign_block_vars('position', array
			(
				'TIME' => $d,
				'SRC' => (isset($_GET['save'])) ? strip_tags($row['src']) : $row['src'],
				'SRC_PORT' => $row['srcport'],
				'SRC_PORT_HINT' => $src_port_hint,
				'DST' => (isset($_GET['save'])) ? strip_tags($row['dst']) : $row['dst'],
				'DST_PORT' => $row['dstport'],
				'DST_PORT_HINT' => $dst_port_hint,
				'LENGTH' => $length,
				'PROTOCOL' => $protocol[0],
				'PROTOCOL_HINT' => $protocol[1],
				'ACCOUNT' => $acc_name
			));      
        }
		if ($_SESSION['filter']['resolve']) set_dns_cache($_CONFIG['CACHE_DIR'] . 'dns', $dns_cache);
		$_USER['SUM_OF_PAGE'] = $_LANG['SUM_OF_PAGE'];
		$_USER['SUM'] = sprintf('%.2f', $sum / 1024);
		$_USER['SUMMARY'] = $_LANG['SUMMARY'] . ': <br />' . $_USER['TOTAL_SUM'] . ' ' . $_LANG['TRAFFIC_UNITS'];
		$_USER['SUMMARY'] = (isset($_GET['save'])) ? strip_tags($_USER['SUMMARY']) : $_USER['SUMMARY'];
		if ($table_data['nav_code']!='') $_USER['NAV_CODE'] =  $_LANG['PAGES'] . ":&nbsp;&nbsp;" . $table_data['nav_code'];
	}
	else
		$_USER['NAV_CODE'] = $_LANG['DATA_NOT_FOUND'] . '<br /><br />';
}

# get the script end time
$_USER['SCRIPT_TIME'] = sprintf('%.2f', getmicrotime() - $time1) . ' ' . $_LANG['TIME_UNITS'];
		
# working with template main.tpl
$template->assign_vars(array_merge(array_add_prefix_to_keys($_USER, 'U_'), array_add_prefix_to_keys($_CONFIG, 'C_'), array_add_prefix_to_keys($_VARS, 'V_'), array_add_prefix_to_keys($_LANG, 'L_')));

# parse & output template
$template->pparse('tpl');

# get contents of output buffer & stop buffering
$output = ob_get_clean();

# convert encoding for saving if needed
if (isset($_GET['save'])) $output = my_iconv('utf-8', $_CONFIG['SAVE_STAT_FILE_ENCODING'], $output);

# output data
echo $output;

?>